import requests, time
from faker import Faker


class HTMLDownloader:

    def __init__(self):
        fake = Faker()
        self.user_agent = fake.user_agent()

    def download(self, url):
        if url is None:
            return None
        headers = {'User-Agent': self.user_agent}
        r = requests.get(url, headers=headers)
        if r.status_code == 200:
            r.encoding = "utf-8"
            # print(r.text)
            return r.text
        return None
