from lxml import etree
from urllib.parse import urljoin
import re


class HTMLParser(object):

    def __init__(self):
        self.base_url = "http://www.woniuxy.com/"

    def parser(self, page_url, html_content):
        # 根据url的内容判断当前是列表页还是详情页
        if html_content is None:
            return None

        html = etree.HTML(html_content)
        new_urls = None
        new_data = None
        # 判断当前链接是详情链接还是列表链接
        if 'page' in page_url: # 列表链接地址就提取链接
            new_urls = self._get_new_urls(html)
        else: # 详情地址就提取数据
            new_data = self._get_new_data(html)
        return new_urls, new_data

    # 获取所有链接
    def _get_new_urls(self, html):
        new_urls = set()
        '''先拿列表中每篇文章的详情链接'''
        detail_links = html.xpath("//div[@class='title']/a")
        for link in detail_links:
            new_url = link.get('href')
            new_full_url = urljoin(self.base_url, new_url)
            print('新文章链接:' + new_full_url)
            new_urls.add(new_full_url)
        '''拿下一页链接，如果到最后重复了，set会自动进行过滤'''
        next_page_link = html.xpath("//*[text()='下一页']")[0]
        print('下一页链接: ' + urljoin(self.base_url, next_page_link.get('href')))
        new_urls.add(urljoin(self.base_url, next_page_link.get('href')))
        return new_urls

    #获取内容页的数据
    def _get_new_data(self, html):

        data = dict()

        #获取文章标题
        data['title'] = html.xpath("//div[contains(@class, 'title')]")[0].text.strip()
        print('标题：' + data['title'])

        info_obj = html.xpath("//div[contains(@class, 'info')]")[1].text
        #正则抽取发布日期和阅读数
        result = re.findall('日期：(\d{4}-\d{2}-\d{2})\s+阅读：(\d+)\s次', info_obj, re.S)
        (data['date'], data['readcount']) = result[0]
        return data