from data_output import DataOutput
from html_downloader import HTMLDownloader
from html_parser import HTMLParser
from url_manager import URLManager


class SpiderMain:

    def __init__(self):
        self.manager = URLManager()
        self.parser = HTMLParser()
        self.downloader = HTMLDownloader()
        self.output = DataOutput()

    def crawl(self, root_url):
        self.manager.add_new_url(root_url)
        while self.manager.has_new_url():
            try:
                new_url = self.manager.get_new_url()
                print("开始抓取{}".format(new_url))
                html = self.downloader.download(new_url)
                new_urls, data = self.parser.parser(new_url, html)
                if data:
                    self.output.store_data(data)
                if new_urls:
                    self.manager.add_new_urls(new_urls)
                print("已抓取{}个链接".format(self.manager.old_url_size()))
            except:
                print("crawl failed")
        self.output.output_file()

if __name__ == '__main__':
    spider_main = SpiderMain()
    spider_main.crawl("http://www.woniuxy.com/note/page-1")